/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPORISCO                                                */
/* Tabela : TIPORISCO                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPORISCO' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_TIPORISCO
GO

CREATE TRIGGER DTULTATU_TIPORISCO
ON TIPORISCO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPORISCO', null, 'CDTIPRISCO=' + CDTIPRISCO + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPORISCO
      SET DTULTATUTPRI = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TIPORISCO.CDTIPRISCO,0)  = ISNULL(INSERTED.CDTIPRISCO,0)) AND
            (ISNULL(TIPORISCO.NMTIPORISCO,0) = ISNULL(INSERTED.NMTIPORISCO,0));
   END;
END;
GO

