/* Sistemas Integrados TECNISA

Nome: 5031_FISTRGO.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   21/06/2012 - Marcelo Alexsandro

Tabela REGRAFISCAL: Regra Fiscal.
Descrio: A trigger insere registros na tabela LOGREGRAFISCAL a partir de alteraes na tabela REGRAFISCAL
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_FIS_REGRAFISCAL' AND
                 TYPE   = 'TR' 	           AND
	              U.UID  = O.UID             AND
	              U.NAME = USER)
DROP TRIGGER LOG_FIS_REGRAFISCAL
GO

CREATE TRIGGER LOG_FIS_REGRAFISCAL
ON REGRAFISCAL
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_USUARIO    VARCHAR(40);
   DECLARE @V_DTOPER     DATETIME;

   DECLARE @V_ID_COMANDO VARCHAR(1);
   DECLARE @V_DESC       VARCHAR(350);
   DECLARE @V_ITPESQ     VARCHAR(40);
   DECLARE @V_NMOPERADOR VARCHAR(40);
   DECLARE @V_IDTIPOOPER VARCHAR(1);

   DECLARE @V_CDREGRAFISC_OLD       VARCHAR(10);
   DECLARE @V_NMREGRAFISC_OLD       VARCHAR(50);
   DECLARE @V_CDGRUPIMPOSTO_OLD     VARCHAR(10);
   DECLARE @V_DSMENSREGRAFISC_OLD   VARCHAR(150);
   DECLARE @V_DTVALREGRAFISC_OLD    DATETIME;
   DECLARE @V_IDATIVREGRAFISC_OLD   VARCHAR(1);
   DECLARE @V_IDUTGRUPOFISCAL_OLD   VARCHAR(1);

   DECLARE @V_CDREGRAFISC_NEW       VARCHAR(10);
   DECLARE @V_NMREGRAFISC_NEW       VARCHAR(50);
   DECLARE @V_CDGRUPIMPOSTO_NEW     VARCHAR(10);
   DECLARE @V_DSMENSREGRAFISC_NEW   VARCHAR(150);
   DECLARE @V_DTVALREGRAFISC_NEW    DATETIME;
   DECLARE @V_IDATIVREGRAFISC_NEW   VARCHAR(1);
   DECLARE @V_IDUTGRUPOFISCAL_NEW   VARCHAR(1);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   SET @V_DESC       = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO @V_NMOPERADOR;
   SET @V_NMOPERADOR = ISNULL(@V_NMOPERADOR, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
     'D' IDCOMANDO,
     DELETED.CDREGRAFISC,
     DELETED.NMREGRAFISC,
     DELETED.CDGRUPIMPOSTO,
     DELETED.DSMENSREGRAFISC,
     DELETED.DTVALREGRAFISC,
     DELETED.IDATIVREGRAFISC,
     DELETED.IDUTGRUPOFISCAL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL
   FROM
     DELETED
   WHERE
     CDREGRAFISC NOT IN (SELECT CDREGRAFISC FROM INSERTED)

   UNION ALL

   SELECT
     'U' IDCOMANDO,
     DELETED.CDREGRAFISC,
     DELETED.NMREGRAFISC,
     DELETED.CDGRUPIMPOSTO,
     DELETED.DSMENSREGRAFISC,
     DELETED.DTVALREGRAFISC,
     DELETED.IDATIVREGRAFISC,
     DELETED.IDUTGRUPOFISCAL,
     INSERTED.CDREGRAFISC,
     INSERTED.NMREGRAFISC,
     INSERTED.CDGRUPIMPOSTO,
     INSERTED.DSMENSREGRAFISC,
     INSERTED.DTVALREGRAFISC,
     INSERTED.IDATIVREGRAFISC,
     INSERTED.IDUTGRUPOFISCAL
   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.CDREGRAFISC = DELETED.CDREGRAFISC

   UNION ALL

   SELECT
     'I' IDCOMANDO,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     INSERTED.CDREGRAFISC,
     INSERTED.NMREGRAFISC,
     INSERTED.CDGRUPIMPOSTO,
     INSERTED.DSMENSREGRAFISC,
     INSERTED.DTVALREGRAFISC,
     INSERTED.IDATIVREGRAFISC,
     INSERTED.IDUTGRUPOFISCAL
   FROM INSERTED
   WHERE CDREGRAFISC NOT IN (SELECT CDREGRAFISC FROM DELETED);
   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDREGRAFISC_OLD,
                                 @V_NMREGRAFISC_OLD,
                                 @V_CDGRUPIMPOSTO_OLD,
                                 @V_DSMENSREGRAFISC_OLD,
                                 @V_DTVALREGRAFISC_OLD,
                                 @V_IDATIVREGRAFISC_OLD,
                                 @V_IDUTGRUPOFISCAL_OLD,
                                 @V_CDREGRAFISC_NEW,
                                 @V_NMREGRAFISC_NEW,
                                 @V_CDGRUPIMPOSTO_NEW,
                                 @V_DSMENSREGRAFISC_NEW,
                                 @V_DTVALREGRAFISC_NEW,
                                 @V_IDATIVREGRAFISC_NEW,
                                 @V_IDUTGRUPOFISCAL_NEW;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'U' BEGIN
         SET @V_DESC = 'Nome = '              +  ' ' + @V_NMREGRAFISC_NEW     + ' '+
                       'Grupo Imposto = '     +  ' ' + @V_CDGRUPIMPOSTO_NEW   + ' '+
                       'Obs.: = '             +  ' ' + ISNULL(@V_DSMENSREGRAFISC_NEW, ' ') + ' '+
                       'Status = '            +  ' ' + @V_IDATIVREGRAFISC_NEW + ' '+
                       'Uti Grupo Fiscal = '  +  ' ' + @V_IDUTGRUPOFISCAL_NEW + ' '+
                       'Validade = '          +  ' ' + CONVERT(VARCHAR, @V_DTVALREGRAFISC_NEW, 103);
         SET @V_ITPESQ = @V_CDREGRAFISC_NEW;
         SET @V_IDTIPOOPER = '2';
      END
      ELSE BEGIN
         IF @V_ID_COMANDO = 'I' BEGIN
            SET @V_DESC = 'Nome = '              +  ' ' + @V_NMREGRAFISC_NEW     + ' '+
                          'Grupo Imposto = '     +  ' ' + @V_CDGRUPIMPOSTO_NEW   + ' '+
                          'Obs.: = '             +  ' ' + ISNULL(@V_DSMENSREGRAFISC_NEW, ' ') + ' '+
                          'Status = '            +  ' ' + @V_IDATIVREGRAFISC_NEW + ' '+
                          'Uti Grupo Fiscal = '  +  ' ' + @V_IDUTGRUPOFISCAL_NEW + ' '+
                          'Validade = '          +  ' ' + CONVERT(VARCHAR, @V_DTVALREGRAFISC_NEW, 103);
            SET @V_ITPESQ = @V_CDREGRAFISC_NEW;
            SET @V_IDTIPOOPER = '1';
         END
         ELSE BEGIN
            IF @V_ID_COMANDO = 'D' BEGIN
               SET @V_DESC = 'Nome = '              +  ' ' + @V_NMREGRAFISC_OLD     + ' '+
                             'Grupo Imposto = '     +  ' ' + @V_CDGRUPIMPOSTO_OLD   + ' '+
                             'Obs.: = '             +  ' ' + ISNULL(@V_DSMENSREGRAFISC_OLD, ' ') + ' '+
                             'Status = '            +  ' ' + @V_IDATIVREGRAFISC_OLD + ' '+
                             'Uti Grupo Fiscal = '  +  ' ' + @V_IDUTGRUPOFISCAL_OLD + ' '+
                             'Validade = '          +  ' ' + CONVERT(VARCHAR, @V_DTVALREGRAFISC_OLD, 103);
               SET @V_ITPESQ = @V_CDREGRAFISC_OLD;
               SET @V_IDTIPOOPER = '3';
            END;
         END;
      END;
      INSERT INTO LOGREGRAFISCAL
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          DSOPERACAO,
          CDPESQITEM)
       VALUES
         ('REGRAFISCAL',
          GETDATE(),
          ISNULL(@V_NMOPERADOR,' '),
          @V_IDTIPOOPER,
          @V_DESC,
          @V_ITPESQ);
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_CDREGRAFISC_OLD,
                                    @V_NMREGRAFISC_OLD,
                                    @V_CDGRUPIMPOSTO_OLD,
                                    @V_DSMENSREGRAFISC_OLD,
                                    @V_DTVALREGRAFISC_OLD,
                                    @V_IDATIVREGRAFISC_OLD,
                                    @V_IDUTGRUPOFISCAL_OLD,
                                    @V_CDREGRAFISC_NEW,
                                    @V_NMREGRAFISC_NEW,
                                    @V_CDGRUPIMPOSTO_NEW,
                                    @V_DSMENSREGRAFISC_NEW,
                                    @V_DTVALREGRAFISC_NEW,
                                    @V_IDATIVREGRAFISC_NEW,
                                    @V_IDUTGRUPOFISCAL_NEW;
   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIS_REGRAFISCAL','5.30.xxx';
GO
